//+-----------------------------------------------------------------------------------+
//|                                     ZZ_All Quotings EXP Exchange+Metals 0-0010.mq4|
//|                                     Copyright  Zhunko                            |
//|31.03.2007                           MF ZHUNKO zhunko@mail.ru                      |
//+-----------------------------------------------------------------------------------+
//|              |
//| .                                                                          |
//|     ZZ_All Quotings Exchange+Metals 0-0030.                    |
//+-----------------------------------------------------------------------------------+ 
#property copyright "Copyright  2007 Zhunko"            
#property link      "zhunko@mail.ru"
//---- .---------------------------------------------
extern int  Timer = 60; // .    ,     .
//---- .------------------------------------------
datetime Market_Info, Mark_Inf, iTimeBegin, TimeTemp;
int      a, b, p, h, ee, eee, epp, ejj, eii, mm, mmm, mii, mpp, mjj;
int      ArraySizeCurrency, ArraySizeMetals;
int      differE, differM;
int      size;
string   infoE, infoM;
//----.--------------------------------------------------------
datetime time[];
int    ArrayTimFram_time[12] = {1, 5, 15, 30, 60, 240, 1440, 10080, 43200};
string ArrayCurrency[] = {"AUD", "ALL", "ARS", "BRL", "BWP", "CAD", "CCK", "CHF", "CLP", "CNY", "COP", "CVE", "CYP", "CZK", "DKK", "DOP", "DZD", "EGP", "EUR", "GBP",
                          "GEL", "GIP", "HKD", "HRK", "HUF", "IDR", "IRR", "ILS", "INR", "ISK", "JPY", "KRW", "LBR", "LSL", "LTL", "LVL", "MAD", "MTL", "MXN", "MYR",
                          "NOK", "NPR", "NZD", "PHP", "PKR", "PLN", "QAR", "RUB", "RUR", "SAR", "SEK", "SGD", "SKK", "THB", "TND", "TRY", "TWD", "UAH", "USD", "XOF",
                          "ZAR", "ZMK"};
string ArrayMetals[]   = {"GOLD", "PALL", "PALLADIUM", "PLAT", "PLATINUM", "SILVER", "XAG", "XAU"};
string ArrayTimfram_str[9] = {"M1 ", "M5 ", "M15", "M30", "H1 ", "H4 ", "D1 ", "W1 ", "MN1"};
string ArrayInCorrectExchange[100000000];
string ArrayInCorrectMetals[100000000];
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
 {
  ArraySizeCurrency = ArraySize (ArrayCurrency);
  ArraySizeMetals = ArraySize (ArrayMetals);
  differE = 9 * MathPow (ArraySizeCurrency, 2);
  differM = 9 * ArraySizeMetals;   
  return(0);
 }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
 {
  if ((TimeLocal() - TimeTemp) / 60 >= Timer)
   {
    //  .
    for (a = 0; a < ArraySizeCurrency; a++) //   .
     for (b = 0; b < ArraySizeCurrency; b++)
      {
       eii++;
       Market_Info = MarketInfo (ArrayCurrency[a] + ArrayCurrency[b], MODE_TIME);
       if (ArrayCurrency[a] != ArrayCurrency[b] && Market_Info != 0)
        {
         ee++;
         for (p = 0; p <= 8; p++)
          {
           epp++;
           Mark_Inf = Market_Info - 60 * ArrayTimFram_time[p];
           iTimeBegin = iTime (ArrayCurrency[a] + ArrayCurrency[b], ArrayTimFram_time[p], 0);
           while (Mark_Inf < iTimeBegin)
            {
             ejj++;
             Comment("  ",
                     "\n: ", 100 * (9 * eii - 8 + p) / differE, " %",
                     "\n: ", " ", ee, ". ", ArrayCurrency[a] + ArrayCurrency[b],
                     "\n: ", ArrayTimfram_str[p],
                     "\n  : ", size); 
             size = ArrayCopySeries (time, MODE_TIME, ArrayCurrency[a] + ArrayCurrency[b], ArrayTimFram_time[p]);
             if (GetLastError() == 0) break;
             if (IsStopped() == true) return;
            }
          }
        }
      }      
    if (ee != 0) infoE = StringConcatenate ("     = ", eii,
                                            "\n       = ", ee,
                                            "\n     = ", epp,
                                            "\n      = ", ejj);
    else infoE = "";
    // .
    for (a = 0; a < ArraySizeMetals; a++) //  .
     {
      mii++;
      Market_Info = MarketInfo (ArrayMetals[a], MODE_TIME);
      if (Market_Info != 0)
       {
        mm++;
        for (p = 0; p <= 8; p++)
         {
          mpp++;
          Mark_Inf = Market_Info - 60 * ArrayTimFram_time[p];
          iTimeBegin = iTime (ArrayMetals[a], ArrayTimFram_time[p], 0);
          while (Mark_Inf < iTimeBegin)
           {
            mjj++;
            Comment(" ",
                    "\n: ", 100 * (9 * mii - 8 + p) / differM, " %",
                    "\n: ", " ", mm, ". ", ArrayMetals[a],
                    "\n: ", ArrayTimfram_str[p],
                    "\n  : ", size);
            size = ArrayCopySeries (time, MODE_TIME, ArrayMetals[a], ArrayTimFram_time[p]);
            if (GetLastError() == 0) break;
            if (IsStopped() == true) return;
           }
         }
       }
     }      
    if (mm != 0) infoM = StringConcatenate ("    = ", mii,
                                            "\n      = ", mm,
                                            "\n    = ", mpp,
                                            "\n     = ", mjj);
    else infoM = "";
    Comment (infoE, "\n", infoM);
   }
  TimeTemp = TimeLocal();
  return;
 }
//=================================================================================================================================================================================